; FAPI2.ASM
; ---------
; uFMOD public source code release. (MiniFMOD v1.70 based.) Provided as-is.
; Original Visual C++ source optimized and debugged by Asterix and Quantum.
; uFMOD sourcecode is (c)opyleft [WASM.RU]. All rights reserved & reversed.
; MiniFMOD sourcecode is (c)opyright Firelight Technologies (R), 2000-2005.
; uFMOD sourcecode is in no way representative of FMOD 3 source.
; This source must not be redistributed without this notice.

.486
.model flat,stdcall
option casemap:none

include music.inc

externdef uFMOD_RealBlock:DWORD
externdef TimeInfo:DWORD

.CODE

; private aux function
x PROC PRIVATE
option prologue:none
option epilogue:none
   mov eax,uFMOD_RealBlock
   mov edx,TimeInfo
   ; eax = uFMOD_RealBlock * sizeof(FMUSIC_TIMMEINFO) / 2
   ; eax = eax * 3
   lea eax,[eax+eax*2]
   retn
x ENDP

; DESCRIPTION: Returns the song's current order number
; PARAMETERS: none
uFMOD_GetOrder PROC
option prologue:none
option epilogue:none
   call x
   movzx eax,(FMUSIC_TIMMEINFO PTR [edx+eax*2]).order
   retn
uFMOD_GetOrder ENDP

; DESCRIPTION: Returns the song's current row number
; PARAMETERS: none
uFMOD_GetRow PROC
option prologue:none
option epilogue:none
   call x
   movzx eax,(FMUSIC_TIMMEINFO PTR [edx+eax*2]).row
   retn
uFMOD_GetRow ENDP

; DESCRIPTION: Returns the time in milliseconds since the song was started.
; This is useful for synchronizing purposes becuase it will be exactly the
; same every time, and it is reliably retriggered upon starting the song.
; Trying to synchronize using other windows timers can lead to varying
; results, and inexact performance. This fixes that problem by actually
; using the number of samples sent to the soundcard as a reference
; PARAMETERS: none
uFMOD_GetTime PROC
option prologue:none
option epilogue:none
   call x
   mov eax,(FMUSIC_TIMMEINFO PTR [edx+eax*2]).ms
   retn
uFMOD_GetTime ENDP

end
