; FMUSIC.ASM
; ----------
; uFMOD public source code release. (MiniFMOD v1.70 based.) Provided as-is.
; Original Visual C++ source optimized and debugged by Asterix and Quantum.
; uFMOD sourcecode is (c)opyleft [WASM.RU]. All rights reserved & reversed.
; MiniFMOD sourcecode is (c)opyright Firelight Technologies (R), 2000-2005.
; uFMOD sourcecode is in no way representative of FMOD 3 source.
; This source must not be redistributed without this notice.

.486
.model flat,stdcall
option casemap:none

INFO_API_ENABLED TEXTEQU <1>
; Uncomment to disable information API (even smaller footprint)
; INFO_API_ENABLED TEXTEQU <0>

include music.inc

_FMUSIC_LoadXM PROTO SYSCALL :DWORD
_FMUSIC_UpdateXM PROTO SYSCALL :DWORD
uFMOD_FPU_Ramp PROTO :DWORD,:DWORD

PUBLIC uFMOD_fread,uFMOD_fseek
PUBLIC uFMOD_Channel
if INFO_API_ENABLED
PUBLIC TimeInfo,uFMOD_RealBlock
endif

.DATA
uFMOD_xm_mem        dd OFFSET xm_memory_open
                    dd OFFSET xm_memory_open
                    dd OFFSET xm_memory_read
                    dd OFFSET xm_memory_seek
uFMOD_xm_rc         dd OFFSET xm_resource_open
                    dd OFFSET xm_resource_close
                    dd OFFSET xm_memory_read
                    dd OFFSET xm_memory_seek
uFMOD_xm_fs         dd OFFSET xm_file_open
                    dd OFFSET xm_file_close
                    dd OFFSET xm_file_read
                    dd OFFSET xm_file_seek

.DATA?
uFMOD_Channel       FMUSIC_CHANNEL 32 dup(<>) ; channel array for this song
uFMOD_MixBlock      FSOUND_SoundBlock<>
_mod                dd ? ; currently playing track

; thread control variables
FSOUND_SW_ThreadRun dd ?
uFMOD_RealBlock     dd ?
WaveOutHandle       dd ? ; HWAVEOUT

; *** LPCALLBACKS ***
; Pointers to std or user-defined functions,
; used to open, close, ... XM stream
uFMOD_fopen         dd ?
uFMOD_fclose        dd ?
uFMOD_fread         dd ?
uFMOD_fseek         dd ?
NUM_CALLBACKS       EQU ($ - uFMOD_fopen) / DWORD
; *******************

; *** _MMF_STRUCT ***
mmf_length          dd ?
mmf_pos             dd ?
mmf_data            dd ?
; *******************

handle              dd ? ; used with XM_RESOURCE and XM_FILE

; mixing thread termination flag
FSOUND_SW_Exit      dd ?
; mix buffer memory block
FSOUND_MixBufMem    dd ?
FSOUND_MixBuf       dd ?
if INFO_API_ENABLED
TimeInfo            dd ? ; PTR FMUSIC_TIMMEINFO
endif
xmod                dd ? ; PTR FMUSIC_MODULE
uFMOD_FillBlock     dd ?

.CODE

; Private function
FMUSIC_SetBPM PROC module:DWORD,bpm:DWORD
option prologue:none
option epilogue:none
   mov eax,FSOUND_MixRate * 5 / 2
   mov ecx,[esp + 8] ; bpm
   cdq
   div ecx
   mov ecx,[esp + 4] ; module
   mov [ecx + FMUSIC_MODULE.mixer_samplespertick],eax
   retn 8
FMUSIC_SetBPM ENDP

; DESCRIPTION: Starts a song playing. Returns true on success
; PARAMETERS:
uFMOD_PlaySong PROC lpXM:DWORD,param:DWORD,fdwSong:DWORD
option prologue:none
option epilogue:none
LOCAL pcmwf:WAVEFORMATEX
   push ebp
   mov ebp,esp
   sub esp,14h
   push esi
   push edi
   ; FREE PREVIOUS TRACK
   call uFMOD_FreeSong
   cmp lpXM,0
   je R ; user requested to stop playback
   ; SET CALLBACKS
   xor eax,eax
   mov ecx,fdwSong
   mov edx,param
   mov mmf_length,edx
   mov handle,edx
   mov mmf_pos,eax
   dec cl ; only 8 LSBs currently used
   mov esi,OFFSET uFMOD_xm_rc
   js set_callbacks   ; 0 == XM_RESOURCE
   mov esi,OFFSET uFMOD_xm_mem
   jz set_callbacks   ; 1 == XM_MEMORY
   mov esi,OFFSET uFMOD_xm_fs
                      ; 2 == XM_FILE
set_callbacks:
   mov edi,OFFSET uFMOD_fopen
   lea ecx,[eax + NUM_CALLBACKS]
   rep movsd
   ; INIT OUTPUT PCM DRIVER
   push eax ; waveOutOpen:fdwOpen
   push eax ; waveOutOpen:dwCallbackInstance
   push eax ; waveOutOpen:dwCallback
   lea edx,pcmwf
   push edx ; waveOutOpen:pwfx
   dec eax
   push eax ; waveOutOpen:uDeviceID (-1)
   mov DWORD PTR [pcmwf.wFormatTag],20001h ; wFormatTag <= WAVE_FORMAT_PCM, nChannels <= 2
   mov DWORD PTR [pcmwf.nBlockAlign],100004h ; wBitsPerSample <= 16, nBlockAlign <= 4
   mov DWORD PTR [pcmwf.nSamplesPerSec],FSOUND_MixRate
   mov DWORD PTR [pcmwf.nAvgBytesPerSec],FSOUND_MixRate * 4
   push offset WaveOutHandle ; waveOutOpen:phwo
   call waveOutOpen
   test eax,eax
   cdq
   xchg eax,edx
   jnz R ; couldn't open PCM driver
   ; LOAD NEW TRACK
   push SIZEOF FMUSIC_MODULE
   push LMEM_ZEROINIT
   call LocalAlloc
   xchg eax,edi
   push lpXM
   call uFMOD_fopen
   push edi
   call _FMUSIC_LoadXM
   test eax,eax
   jnz close
free:
   push edi
   call uFMOD_FreeSong
   xor edi,edi
close:
   call uFMOD_fclose
   pop ecx
   pop ecx ; fix stack
   xchg eax,edi
   test eax,eax
   mov _mod,eax
   jz R ; could not load XM
   xchg eax,esi
   ; ALLOC GLOBAL CHANNEL POOL
   mov ecx,SIZEOF FSOUND_CHANNEL * 256 / 4
   xor eax,eax
   mov edi,offset FSOUND_Channel
   rep stosd
   mov ecx,SIZEOF FMUSIC_CHANNEL * 32 / 4
   mov edi,offset uFMOD_Channel
   rep stosd
   ; SET UP CHANNELS
   mov eax,(offset FSOUND_Channel + SIZEOF FSOUND_CHANNEL * 256)
   dec cl ; ecx <= 255
   cdq
   inc edx ; edx <= 1
loop_1:
   sub eax,SIZEOF FSOUND_CHANNEL
   mov [eax],ecx ; FSOUND_Channel[count].index <= count
   mov [eax + FSOUND_CHANNEL.speedhi],edx ; FSOUND_Channel[count].speedhi <= 1
   dec ecx
   jns loop_1
   lea edi,[esi + 12Ah]
   mov [edi + FMUSIC_MODULE.nextorder - 12Ah],ecx ; <= -1
   mov [edi + FMUSIC_MODULE.nextrow - 12Ah],ecx ; <= -1
   dec edx ; edx <= 0
   mov [esi + FMUSIC_MODULE.mixer_samplesleft],edx ; <= 0
   mov [edi + FMUSIC_MODULE.row - 12Ah],edx ; <= 0
   mov [edi + FMUSIC_MODULE.order - 12Ah],edx ; <= 0
   mov [edi + FMUSIC_MODULE.tick - 12Ah],edx ; <= 0
   mov [edi + FMUSIC_MODULE.patterndelay - 12Ah],edx ; <= 0
   mov [edi + FMUSIC_MODULE.time_ms - 12Ah],edx ; <= 0
   movzx ecx,WORD PTR [esi + FMUSIC_MODULE.numchannels] ; loop counter
   test ecx,ecx
   jz loop_2_end
   ; eax == offset FSOUND_Channel
loop_2:
   mov DWORD PTR [uFMOD_Channel.cptr][edx],eax
   add eax,SIZEOF FSOUND_CHANNEL
   add edx,SIZEOF FMUSIC_CHANNEL
   loop loop_2
loop_2_end:
   mov WORD PTR [pcmwf.cbSize],cx
   movsx eax,WORD PTR [esi + FMUSIC_MODULE.defaultspeed]
   mov [edi + FMUSIC_MODULE.speed - 12Ah],eax ; <= defaultspeed
   movsx eax,WORD PTR [esi + FMUSIC_MODULE.defaultbpm]
   mov DWORD PTR [edi + FMUSIC_MODULE.globalvolume - 12Ah],64
   mov xmod,esi
   push eax
   push esi
   call FMUSIC_SetBPM
   mov edi,LocalAlloc
if INFO_API_ENABLED
   push SIZEOF FMUSIC_TIMMEINFO * totalblocks
   push LMEM_ZEROINIT
   call edi ; LocalAlloc
   mov TimeInfo,eax
endif
   ; CREATE AND START LOOPING WAVEOUT BLOCK
   mov esi,offset uFMOD_MixBlock
   mov [esi + FSOUND_SoundBlock.wavehdr.dwBytesRecorded],eax
   mov [esi + FSOUND_SoundBlock.wavehdr.dwUser],eax
   mov eax,FSOUND_BufferSize SHL 2
   mov [esi + FSOUND_SoundBlock.wavehdr.dwBufferLength],eax
   push eax
   push LMEM_ZEROINIT
   call edi ; LocalAlloc
   or DWORD PTR [esi + FSOUND_SoundBlock.wavehdr.dwLoops],-1
   mov [esi + FSOUND_SoundBlock.data],eax
   mov [esi + FSOUND_SoundBlock.wavehdr.lpData],eax
   mov [esi + FSOUND_SoundBlock.wavehdr.dwFlags],WHDR_BEGINLOOP or WHDR_ENDLOOP
   push 20h ; SIZEOF WAVEHDR
   push esi ; offset uFMOD_MixBlock.wavehdr
   push WaveOutHandle
   call waveOutPrepareHeader
   ; ALLOCATE MIXBUFFER
   push (FSOUND_BufferSize SHL 3) + 256
   push LMEM_ZEROINIT
   call edi ; LocalAlloc
   xor edi,edi
   mov FSOUND_MixBufMem,eax
   add eax,15
   and al,0F0h
   mov FSOUND_MixBuf,eax
   ; PREFILL THE MIXER BUFFER
loop_3:
   call uFMOD_SW_Fill
   cmp uFMOD_FillBlock,edi
   jnz loop_3
   ; START THE OUTPUT
   push 20h ; SIZEOF WAVEHDR
   push esi ; offset uFMOD_MixBlock.wavehdr
   push WaveOutHandle
   call waveOutWrite
   ; CREATE THREADS / TIMERS (last)
   mov FSOUND_SW_Exit,edi ; <= 0
   lea eax,lpXM
   push eax
   push edi
   push edi
   push offset uFMOD_Thread
   push edi
   push edi
   call CreateThread
   push eax
   call CloseHandle
R:
   pop edi
   pop esi
   leave
   retn 0Ch
uFMOD_PlaySong ENDP

; DESCRIPTION: Frees memory allocated for a song and removes it from the FMUSIC system
; PARAMETERS: none
uFMOD_FreeSong PROC PRIVATE
option prologue:none
option epilogue:none
LOCAL count:DWORD,count2:DWORD,iptr:DWORD,psample:DWORD
   push ebp
   mov ebp,esp
   sub esp,10h
   push esi
   mov eax,_mod
   test eax,eax
   mov esi,eax
   jz R ; NO TRACK - NOTHING TO FREE (return 0)
   push edi
   xor edi,edi
   mov _mod,edi
   push ebx
   mov ebx,LocalFree
   call uFMOD_StopSong
   ; free samples
   cmp [esi + FMUSIC_MODULE.instrument],edi
   jz noinstruments
   cmp [esi + FMUSIC_MODULE.numinsts],di
   mov count,edi
   jle nomoreinstruments
   mov iptr,edi
loop_1:
   mov edi,iptr
   and count2,0
   add edi,[esi + FMUSIC_MODULE.instrument]
   cmp DWORD PTR [edi],0
   jle l1
   lea eax,[edi + FMUSIC_INSTRUMENT.sample]
   mov psample,eax
loop_2:
   mov eax,psample
   mov eax,[eax]
   test eax,eax
   jz l2
   push eax
   push [eax + FSOUND_SAMPLE.buff]
   call ebx ; LocalFree
   call ebx ; LocalFree
l2:
   inc count2
   add psample,4
   mov eax,count2
   cmp eax,[edi + FMUSIC_INSTRUMENT.numsamples]
   jl loop_2
l1:
   movsx eax,[esi + FMUSIC_MODULE.numinsts]
   inc count
   add iptr,114h ; SIZEOF FMUSIC_INSTRUMENT
   cmp count,eax
   jl loop_1
   xor edi,edi
nomoreinstruments:
   ; free instruments
   push [esi + FMUSIC_MODULE.instrument]
   call ebx ; LocalFree
   mov [esi + FMUSIC_MODULE.instrument],edi
noinstruments:
   ; free patterns
   cmp [esi + FMUSIC_MODULE.pattern],edi
   jz nopatterns
   cmp [esi + FMUSIC_MODULE.numpatternsmem],edi
   jle nomorepatterns
loop_3:
   mov eax,[esi + FMUSIC_MODULE.pattern]
   push DWORD PTR [eax + edi*SIZEOF FMUSIC_PATTERN + FMUSIC_PATTERN.data]
   call ebx ; LocalFree
   inc edi
   cmp edi,[esi + FMUSIC_MODULE.numpatternsmem]
   jl loop_3
nomorepatterns:
   push [esi + FMUSIC_MODULE.pattern]
   call ebx ; LocalFree
   and [esi + FMUSIC_MODULE.pattern],0
nopatterns:
   push esi
   call ebx ; LocalFree
   pop ebx
   pop edi
   inc eax ; return TRUE
R:
   pop esi
   leave
   retn
uFMOD_FreeSong ENDP

; DESCRIPTION: Stops a song from playing
; PARAMETERS: none
uFMOD_StopSong PROC PRIVATE
option prologue:none
option epilogue:none
   inc FSOUND_SW_Exit
   push edi
   xor edi,edi
   ; WAIT FOR THE THREAD TO FINISH
wait4thread2finish:
   push 2
   call Sleep
   cmp FSOUND_SW_ThreadRun,edi
   jne wait4thread2finish
   ; FREE THE OUTPUT MIXBUFFER
   push FSOUND_MixBufMem
   mov uFMOD_FillBlock,edi
   mov uFMOD_RealBlock,edi
   mov FSOUND_MixBufMem,edi
if INFO_API_ENABLED
   push TimeInfo
   mov TimeInfo,edi
endif
   mov eax,WaveOutHandle
   cmp uFMOD_MixBlock.wavehdr.lpData,edi
   push eax ; waveOutClose:hwo
   push eax ; waveOutReset:hwo
   jz unprepared
   push 20h ; SIZEOF WAVEHDR
   push offset uFMOD_MixBlock.wavehdr
   push eax ; WaveOutHandle
   call waveOutUnprepareHeader
   and uFMOD_MixBlock.wavehdr.dwFlags,0FFFFFFFDh ; ~WHDR_PREPARED
unprepared:
   ; SHUT DOWN PCM DRIVER
   call waveOutReset
   call waveOutClose
   ; FREE INTERNAL BUFFERS
   push uFMOD_MixBlock.wavehdr.lpData
   mov uFMOD_MixBlock.wavehdr.lpData,edi
   mov edi,LocalFree
   call edi ; LocalFree
if INFO_API_ENABLED
   call edi ; LocalFree
endif
   call edi ; LocalFree
   pop edi
   retn
uFMOD_StopSong ENDP

; Internal function
; ecx == 0 after this function executes
uFMOD_SW_Fill PROC PRIVATE
option prologue:none
option epilogue:none
LOCAL mixbuffer:DWORD,mixpos:DWORD,MixedSoFar:DWORD,SamplesToMix:DWORD,MixPtr:DWORD
   push ebp
   mov ebp,esp
   sub esp,14h
   mov eax,uFMOD_FillBlock
   mov ecx,FSOUND_MixBuf
   push ebx
   mov ebx,FSOUND_BlockSize
   imul ebx
   push edi
   lea edi,[ecx + eax * 8]
   mov mixpos,eax ; mixpos <= uFMOD_FillBlock * FSOUND_BlockSize
   xor eax,eax
   mov mixbuffer,edi ; mixbuffer <= FSOUND_MixBuf + (mixpos << 3)
   mov MixPtr,edi
   ; MIXBUFFER CLEAR
   lea ecx,[ebx * 2]
   mov MixedSoFar,eax
   rep stosd
   ; UPDATE MUSIC
   mov eax,xmod
   mov edi,[eax + FMUSIC_MODULE.mixer_samplesleft]
   push esi
loop_1:
   test edi,edi
   jnz mixedleft_nz
   mov eax,xmod
   push eax
   mov eax,[eax + FMUSIC_MODULE.mixer_samplespertick]
   mov SamplesToMix,eax
   mov edi,eax
   call _FMUSIC_UpdateXM
   pop ecx
mixedleft_nz:
   mov esi,edi
   mov SamplesToMix,edi
   mov eax,MixedSoFar
   lea ecx,[edi + eax]
   cmp ecx,ebx
   jbe _ramp
   mov esi,ebx
   sub esi,eax
   mov SamplesToMix,esi
_ramp:
   push esi
   push MixPtr
   call uFMOD_FPU_Ramp
   pop ecx
   pop ecx
   add MixedSoFar,esi ; MixedSoFar += SamplesToMix
   mov eax,MixPtr
   lea eax,[eax + esi * 8]
   mov MixPtr,eax ; MixPtr += (SamplesToMix << 3)
   sub edi,esi ; MixedLeft -= SamplesToMix
   lea eax,[esi + esi * 4]
   cdq
   shl eax,1
   mov ecx,441
   div ecx
   mov edx,xmod
   ; xmod->time_ms += SamplesToMix * FSOUND_OOMixRate * 1000
   add [edx + FMUSIC_MODULE.time_ms],eax
   cmp MixedSoFar,ebx
   jb loop_1
   mov [edx + FMUSIC_MODULE.mixer_samplesleft],edi ; <= MixedLeft
if INFO_API_ENABLED
   mov eax,uFMOD_FillBlock
   lea edi,[eax + eax * 2] ; edi <= uFMOD_FillBlock * SIZEOF FMUSIC_TIMMEINFO / 2
   mov esi,TimeInfo
   mov ecx,[edx + FMUSIC_MODULE.time_ms]
   mov [esi + edi * 2 + FMUSIC_TIMMEINFO.ms],ecx
   mov cl,BYTE PTR [edx + FMUSIC_MODULE.row]
   mov [esi + edi * 2 + FMUSIC_TIMMEINFO.row],cl
   mov cl,BYTE PTR [edx + FMUSIC_MODULE.order]
   mov [esi + edi * 2 + FMUSIC_TIMMEINFO.order],cl
endif
   ; CLIP AND COPY BLOCK TO OUTPUT BUFFER
   mov eax,mixpos
   mov edx,uFMOD_MixBlock.data
   lea edi,[edx + eax * 4] ; <dest. ptr> = uFMOD_MixBlock.data + mixpos << 2
   mov edx,7FFFh           ; upper bound
   mov esi,-32768          ; lower bound
   mov ecx,6E8h            ; <loop counter> = FSOUND_BlockSize << 1
loop_2:
   mov eax,mixbuffer
   fld DWORD PTR [eax]
   add mixbuffer,4
   fistp mixpos
   mov eax,mixpos
   cmp eax,esi
   jge lower_bound_ok
   mov eax,esi
lower_bound_ok:
   cmp eax,edx
   jle upped_bound_ok
   mov eax,edx
upped_bound_ok:
   stosw
   loop loop_2
   ; if(++uFMOD_FillBlock >= totalblocks) uFMOD_FillBlock = 0
   inc uFMOD_FillBlock
   cmp uFMOD_FillBlock,totalblocks
   jl @F
   mov uFMOD_FillBlock,ecx
@@:
   pop esi
   pop edi
   pop ebx
   leave
   retn
uFMOD_SW_Fill ENDP

; Internal thread function
uFMOD_Thread PROC PRIVATE lpdwParam:DWORD
option prologue:none
option epilogue:none
LOCAL mmt:MMTIME
   inc FSOUND_SW_ThreadRun
   push ebp
   mov ebp,esp
   sub esp,0Ch
   mov mmt.wType,4 ; TIME_BYTES
   push esi
loop_1:
   lea eax,mmt
   push SIZEOF MMTIME
   push eax
   push WaveOutHandle
   call waveOutGetPosition
   mov eax,mmt.u.cb
   shr eax,2
   cdq
   mov ecx,FSOUND_BufferSize
   div ecx
   mov ecx,FSOUND_BlockSize
   xchg eax,edx
   cdq
   div ecx ; eax <= ((mmt.u.cb >> 2) % FSOUND_BufferSize) / FSOUND_BlockSize
   xchg eax,esi
loop_2:
   push 2
   call Sleep
   cmp uFMOD_FillBlock,esi
   je loop_2_end
   call uFMOD_SW_Fill
   inc uFMOD_RealBlock
   cmp uFMOD_RealBlock,totalblocks
   jl loop_2
   mov uFMOD_RealBlock,ecx ; ecx == 0 after uFMOD_SW_Fill
   jmp loop_2
loop_2_end:
   cmp FSOUND_SW_Exit,0
   jz loop_1
   pop esi
   dec FSOUND_SW_ThreadRun
   leave
   retn 4
uFMOD_Thread ENDP

; ***************************
; *** XM_MEMORY CALLBACKS ***
; ***************************
xm_memory_open PROC pMem:DWORD
option prologue:none
option epilogue:none
   mov eax,[esp + 4] ; pMem
   mov mmf_data,eax
   retn
xm_memory_open ENDP

xm_memory_read PROC buffer:DWORD,uSize:DWORD
option prologue:none
option epilogue:none
   mov ecx,[esp + 8] ; uSize
   mov edx,mmf_pos
   add edx,ecx
   mov eax,mmf_length
   cmp edx,eax
   jl @F
   sub eax,mmf_pos
   xchg eax,ecx
@@:
   push esi
   mov esi,mmf_data
   add esi,mmf_pos
   push edi
   mov edi,[esp + 12] ; buffer
   mov eax,ecx
   rep movsb
   pop edi
   pop esi
   mov mmf_pos,edx
   retn
xm_memory_read ENDP

xm_memory_seek PROC pos:DWORD,mode:DWORD
option prologue:none
option epilogue:none
   mov eax,OFFSET mmf_pos
   mov edx,[esp + 4] ; pos
   mov ecx,mmf_length
   cmp DWORD PTR [esp + 8],0
   jne seek_cur
   mov [eax],edx ; if(mode == SEEK_SET)
   jmp end_if
seek_cur:
   add [eax],edx ; if(mode == SEEK_CUR)
end_if:
   cmp [eax],ecx
   jle R
   mov [eax],ecx
R:
   mov eax,[eax]
   retn
xm_memory_seek ENDP

; *****************************
; *** XM_RESOURCE CALLBACKS ***
; *****************************
xm_resource_open PROC PRIVATE pszName:DWORD
option prologue:none
option epilogue:none
   push RT_RCDATA
   push [esp + 8] ; pszName
   push handle ; This is HMODULE
   call FindResource
   push eax
   push handle
   push eax
   push handle
   call SizeofResource
   mov mmf_length,eax
   call LoadResource
   mov handle,eax
   push eax
   call LockResource
   mov mmf_data,eax
   mov mmf_pos,0
   retn
xm_resource_open ENDP

xm_resource_close PROC PRIVATE
option prologue:none
option epilogue:none
   push handle
   call FreeResource
   retn
xm_resource_close ENDP

; *************************
; *** XM_FILE CALLBACKS ***
; *************************
xm_file_open PROC PRIVATE szName:DWORD
option prologue:none
option epilogue:none
   xor eax,eax
   push eax
   push FILE_ATTRIBUTE_NORMAL
   push OPEN_EXISTING
   push eax
   push eax
   push GENERIC_READ
   push [esp + 1Ch] ; szName
   call CreateFile
   mov handle,eax
   retn
xm_file_open ENDP

xm_file_close PROC PRIVATE
option prologue:none
option epilogue:none
   push handle
   call CloseHandle
   retn
xm_file_close ENDP

xm_file_read PROC PRIVATE buffer:DWORD,uSize:DWORD
option prologue:none
option epilogue:none
   push 0
   push OFFSET mmf_data
   push [esp + 10h] ; uSize
   push [esp + 10h] ; buffer
   push handle
   call ReadFile
   mov eax,mmf_data
   retn
xm_file_read ENDP

xm_file_seek PROC PRIVATE pos:DWORD,mode:DWORD
option prologue:none
option epilogue:none
   push [esp + 8] ; mode
   push 0
   push [esp + 0Ch] ; pos
   push handle
   call SetFilePointer
   retn
xm_file_seek ENDP

end
