#include <windows.h>

#define IDD_DIALOG_1 300
#define IDB_PLAY     200
#define IDB_STOP     201
#define IDB_EXIT     202
#define MAINICON     400
#define ID_XM        1

long __stdcall DlgProc(HWND,UINT,WPARAM,LPARAM);

#define XM_RESOURCE  0
#define XM_MEMORY    1
#define XM_FILE      2

#ifdef __cplusplus
   extern "C" {
#endif

/* ==============
   uFMOD_PlaySong
   ==============
   The uFMOD_PlaySong function plays a song specified by the given
   filename, resource or image of a song in memory.
   --------------
    BOOL uFMOD_PlaySong(
      LPVOID lpXM,
      DWORD  param,
      DWORD  fdwSong
    );
   --------------
   Parameters:
     lpXM
        Specifies the song to play. If this parameter is NULL,
        any currently playing song is stopped.
        fdwSong parameter determines whether this value is interpreted
        as a filename, as a resource identifier or a pointer to an image
        of the song in memory.
     param
        Handle to the executable file that contains the resource to be
        loaded or size of the image of the song in memory. This parameter
        is ignored unless XM_RESOURCE or XM_MEMORY is specified in fdwSong.
     fdwSong
        Flags for playing the song. The following values are defined.
        Value        Meaning
        XM_FILE      lpXM points to filename;
                     param is ignored.
        XM_MEMORY    lpXM points to an image of a song in memory;
                     param is the image size.
        XM_RESOURCE  lpXM Specifies the name of the resource;
                     param identifies the module whose executable file
                     contains the resource;
                     The resource type must be RT_RCDATA.
  Return Values:
     Returns TRUE if successful or FALSE otherwise.
*/
int __stdcall uFMOD_PlaySong(void*,void*,int);
#define uFMOD_StopSong() uFMOD_PlaySong(0,0,0)

int __stdcall uFMOD_GetOrder();
int __stdcall uFMOD_GetRow();
unsigned int __stdcall uFMOD_GetTime();

#ifdef __cplusplus
   }
#endif
